/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ContactLanguages type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactLanguages{}

// ContactLanguages struct for ContactLanguages
type ContactLanguages struct {
	// Primary language
	Primary *string `json:"primary,omitempty"`
	// JSON with additional languages in format: { [source]: [languge] }
	Additional *map[string]string `json:"additional,omitempty"`
}

// NewContactLanguages instantiates a new ContactLanguages object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactLanguages() *ContactLanguages {
	this := ContactLanguages{}
	return &this
}

// NewContactLanguagesWithDefaults instantiates a new ContactLanguages object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactLanguagesWithDefaults() *ContactLanguages {
	this := ContactLanguages{}
	return &this
}

// GetPrimary returns the Primary field value if set, zero value otherwise.
func (o *ContactLanguages) GetPrimary() string {
	if o == nil || IsNil(o.Primary) {
		var ret string
		return ret
	}
	return *o.Primary
}

// GetPrimaryOk returns a tuple with the Primary field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactLanguages) GetPrimaryOk() (*string, bool) {
	if o == nil || IsNil(o.Primary) {
		return nil, false
	}
	return o.Primary, true
}

// HasPrimary returns a boolean if a field has been set.
func (o *ContactLanguages) HasPrimary() bool {
	if o != nil && !IsNil(o.Primary) {
		return true
	}

	return false
}

// SetPrimary gets a reference to the given string and assigns it to the Primary field.
func (o *ContactLanguages) SetPrimary(v string) {
	o.Primary = &v
}

// GetAdditional returns the Additional field value if set, zero value otherwise.
func (o *ContactLanguages) GetAdditional() map[string]string {
	if o == nil || IsNil(o.Additional) {
		var ret map[string]string
		return ret
	}
	return *o.Additional
}

// GetAdditionalOk returns a tuple with the Additional field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactLanguages) GetAdditionalOk() (*map[string]string, bool) {
	if o == nil || IsNil(o.Additional) {
		return nil, false
	}
	return o.Additional, true
}

// HasAdditional returns a boolean if a field has been set.
func (o *ContactLanguages) HasAdditional() bool {
	if o != nil && !IsNil(o.Additional) {
		return true
	}

	return false
}

// SetAdditional gets a reference to the given map[string]string and assigns it to the Additional field.
func (o *ContactLanguages) SetAdditional(v map[string]string) {
	o.Additional = &v
}

func (o ContactLanguages) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactLanguages) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Primary) {
		toSerialize["primary"] = o.Primary
	}
	if !IsNil(o.Additional) {
		toSerialize["additional"] = o.Additional
	}
	return toSerialize, nil
}

type NullableContactLanguages struct {
	value *ContactLanguages
	isSet bool
}

func (v NullableContactLanguages) Get() *ContactLanguages {
	return v.value
}

func (v *NullableContactLanguages) Set(val *ContactLanguages) {
	v.value = val
	v.isSet = true
}

func (v NullableContactLanguages) IsSet() bool {
	return v.isSet
}

func (v *NullableContactLanguages) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactLanguages(val *ContactLanguages) *NullableContactLanguages {
	return &NullableContactLanguages{value: val, isSet: true}
}

func (v NullableContactLanguages) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactLanguages) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


